meal_plan/urls.py
from django.urls import path

from meal_plan.views import (
    MealPlanListView,  # class and import added to views with weird code to check on
    MealPlanDetailView,  # class and import added to views with pass
    MealPlanDeleteView,  # class and import added to views with the recommended "list" information?
    MealPlanCreateView,  # class and impoer added to views with pass
    MealPlanUpdateView,
)

urlpatterns = [
    path("", MealPlanListView.as_view(), name="meal_plan"),
    path("<int:pk>/", MealPlanDetailView.as_view(), name="meal_plan_detail"),
    path(
        "<int:pk>/delete/",
        MealPlanDeleteView.as_view(),
        name="meal_plan_delete",
    ),
    path("new/", MealPlanCreateView.as_view(), name="meal_plan_new"),
    path("<int:pk>/edit/", MealPlanUpdateView.as_view(), name="meal_plan_edit"),
]

scrumptious/urls.py
from django.contrib import admin
from django.urls import include, path, reverse_lazy
from django.views.generic.base import RedirectView
from django.contrib.auth import views as auth_views

urlpatterns = [
    path("meal_plan/", include("meal_plan.urls")),
    path("accounts/login/", auth_views.LoginView.as_view(), name="login"),
    path("accounts/logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("admin/", admin.site.urls),
    path("recipes/", include("recipes.urls")),
    path("tags/", include("tags.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("recipes_list")),
        name="home",
    ),
]

tags/urls.py
from django.urls import path

from tags.views import (
    TagListView,
    TagDeleteView,
    TagDetailView,
    TagCreateView,
    TagUpdateView,
)

urlpatterns = [
    path("", TagListView.as_view(), name="tags_list"),
    path("<int:pk>/", TagDetailView.as_view(), name="tag_detail"),
    path("<int:pk>/delete/", TagDeleteView.as_view(), name="tag_delete"),
    path("new/", TagCreateView.as_view(), name="tag_new"),
    path("<int:pk>/edit/", TagUpdateView.as_view(), name="tag_edit"),
]

meal_plan/models.py
from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL


class Meal_Plan(models.Model):
    name = models.CharField(max_length=120)
    date = models.DateTimeField(auto_now_add=False)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="recipes_owned",
        on_delete=models.CASCADE,
        null=True,
    )

    recipes = models.ManyToManyField("recipes.Recipe", related_name="recipes")

    def __str__(self):
        return self.name + " by " + str(self.author)

meal_plan/forms.py
# from django.forms import ModelForm

# from meal_plan.models import Meal_Plan


# class MealPlanForm(ModelForm):
#    class Meta:
#        model = Meal_Plan
#        fields = ["name", "date", "recipes"]

# class MealPlanDeleteForm(ModelForm):
#    model = Meal_Plan
#    f

meal_plan/views.py
from django.shortcuts import redirect, render
from django.urls import reverse_lazy
from django.views.generic.detail import DetailView
from django.views.generic.edit import DeleteView, CreateView, UpdateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from meal_plan.models import Meal_Plan

# from meal_plans.forms import MealPlanForm, MealPlanDeleteForm


class MealPlanListView(LoginRequiredMixin, ListView):
    model = Meal_Plan
    template_name = "meal_plan/list.html"
    paginate_by = 10

    def get_queryset(self):
        return Meal_Plan.objects.filter(owner=self.request.user)


class MealPlanDetailView(DetailView):
    model = Meal_Plan
    template_name = "meal_plan/detail.html"

    def get_queryset(self):
        return Meal_Plan.objects.filter(owner=self.request.user)


class MealPlanCreateView(LoginRequiredMixin, CreateView):
    model = Meal_Plan
    template_name = "meal_plan/new.html"
    fields = ["name", "date", "recipes"]

    def form_valid(self, form):
        plan = form.save(commit=False)
        plan.owner = self.request.user
        plan.save()
        form.save_m2m()
        return redirect(
            "meal_plan_detail", pk=plan.id
        )  # meal_plan_detail is redirecting it to the detail page


class MealPlanDeleteView(LoginRequiredMixin, DeleteView):
    model = Meal_Plan
    template_name = "meal_plan/delete.html"
    success_url = reverse_lazy("meal_plan")

    def get_queryset(self):
        return Meal_Plan.objects.filter(owner=self.request.user)


class MealPlanUpdateView(LoginRequiredMixin, UpdateView):
    model = Meal_Plan
    template_name = "meal_plan/edit.html"
    fields = ["name", "date", "recipes"]

    def get_queryset(self):
        return Meal_Plan.objects.filter(owner=self.request.user)

    def get_success_url(self) -> str:
        return reverse_lazy(
            "meal_plan_detail", args=[self.object.id]
        )  # meal_plan_detail is redirecting it to the detail page

meal_plan/templates/meal_plan/delete.html
{% extends 'base.html'%}{% load markdownify %}{% block content %} {% comment %}
do I need markdownify? {% endcomment %}

<main>
  <div class="delete-form">
    <form method="post">
      {% csrf_token %}
      <p>Are you sure you want to delete "{{ recipe }}"?</p>
      {{ form.as_p }}
      <div>
        <button class="button">Delete</button>
      </div>
    </form>
  </div>
</main>
{% endblock content %}

meal_plan/templates/meal_plan/detail.html
{% extends 'base.html'%}{% load markdownify %}{% block content %} {% comment %}
do I need markdownify? {% endcomment %}

<main class="recipe-detail">
  <div>
    <a href="{% url 'meal_plan_edit' meal_plan.id %}">Edit</a>
    <a href="{% url 'meal_plan_delete' meal_plan.id %}">Delete</a>
  </div>
  <h1>{{ meal_plan.name }}</h1>
  <p>To be served on {{ meal_plan.date }}</p>
  <p>
    Recipes: {% for recipe in meal_plan.recipes.all %}<a
      href="{% url 'recipe_detail' recipe.id %}"
      >{{recipe.name}}</a
    >
    {%endfor%}
  </p>
</main>
{% endblock content %}

meal_plan/templates/meal_plan/edit.html
{% extends 'base.html'%} {% load markdownify %} {% block content %}
<main class="recipe-form">
  <form method="post">
    {% csrf_token %} {{ form.as_p }}
    <div class="control">
      <button class="button">Update</button>
    </div>
  </form>
</main>
{% endblock content %}

meal_plan/templates/meal_plan/list.html
{% extends 'base.html' %} {% load markdownify %} {% block pagination %}
<div class="pagination">
  <span class="step-links">
    {% if page_obj.has_previous %}
    <a href="?page=1">&laquo; first</a>
    <a href="?page={{ page_obj.previous_page_number }}">previous</a>
    {% endif %}

    <span class="current">
      Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
    </span>

    {% if page_obj.has_next %}
    <a href="?page={{ page_obj.next_page_number }}">next</a>
    <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
    {% endif %}
  </span>
  <div><a href="{% url 'meal_plan_new' %}">Create</a></div>
</div>
{% endblock pagination %} {% block content %}
<main class="recipe-grid">
  {% for meal_plan in meal_plan_list %}
  <div class="recipe-card">
    <h2 class="recipe-card-title">
      <a href="{% url 'meal_plan_detail' meal_plan.pk %}"
        >{{ meal_plan.name }}</a
      >
    </h2>
    <p class="recipe-card-date">{{ meal_plan.date }}</p>
  </div>
  {% endfor %}
</main>
{% endblock content %}

meal_plan/templates/meal_plan/new.html
{% extends 'base.html'%}{% load markdownify %}{% block content %}
<main class="recipe-form">
  <form method="post">
    {% csrf_token %} {{ form.as_p }}
    <div class="control">
      <button class="button">Create</button>
    </div>
  </form>
</main>
{% endblock content %}